// W3 land
//
#include <stdio.h>
#include <alloc.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

//------------- 1  2--------------------------


int l1s1[]= // -1 -ய //255 - .  //0- 
 {
  86,88,91,87,110,112,255, //city
  92,90,89,78,107,255,
  103,106,101,100,104,255,
  105,102,93,0
 };
int l1s2[]=
 {
  -1,81,84,80,109,111,255,  //build
  85,83,82,255,
  96,99,94,-1,97,255,
  98,95,-1,79,108,0
  };

int l1s3[12][16]= //=-1 - ⢮ //land
 {
   7,30,31,32,39,40,41,61, 3, 6, 9,10,11,26,54,27,
   8,33,34,35,42,43,44,62, 2, 4,12,13,14,52,56,53,
   0,36,37,38,45,46,47,63, 1, 5,15,16,383,28,55,29,
  19,20,21,64,65,66,67,71,72,73,74,57,59,-1,-1,-1,
  18,17,22,68,51,69,70,75,-1,76,77,58,60,-1,-1,-1,
  25,24,23,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  48,49,50,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1, -1, -1,114,116,119,121,124,126,-1,-1,-1,-1,-1,-1,-1,
  113,118,123,115,117,120,122,125,127,-1,-1,-1,-1,-1,-1,-1
 };

int l2s1[12][16]= //land  
 {
    0,  2,  6,  9, 12, 15, 18, 21, 24, 27, 29, 38, 40, -1, -1, -1,
  383,  3, 61, 10, 13, 16, 19, 22, 25, 28, 30, 39, 41, -1, -1, -1,
    1,  4, 63, 11, 14, 17, 20, 23, 26, 52, 53, -1, -1, -1, -1, -1,
   80, 81, 82, 83, 85, 86, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   31, 32, 33, 34, 35, 87, 36, 79, 37, -1, -1, -1, -1, -1, -1, -1,
   56,113,118,123, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   57,114,119,124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   58,115,120,125, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   59,116,121,126, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   60,117,122,127, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   89, 91, 93, 95, 97, 98, 99,101,103,105,107,109,111, -1, -1, -1,
   90, 92, 94, 96, 88,  5,100,102,104,106,108,110,112, -1, -1, -1
 };

//-----------------------------------------------------


 char *t_land=(char*)(malloc(8));
 char buff[192][32];
 char land[12288];
 char *name=(char*)(malloc(70));
//----------------------------------------------------------------
void init_land()
 {
  for (int i=0;i<12288;i++) land[i]=0x55;
 }

#define TIFF 194

void open_f(char *b)
 {
  char *name=(char*)(malloc(70));
  sprintf(name,"..\\images\\%s%s.tif",t_land,b);
  int h=open(name,O_BINARY | O_RDONLY);
  if (h==-1){perror("訡  䠩!\7\n");exit(1);}
  read(h,buff,TIFF);
  read(h,buff,6144);
  char *cc=(char*)buff;
  for (int i=0;i<6144;i++) {*cc^=255; cc++;}
  close(h);
 }

void save_land()
 {
  sprintf(name,"..\\DATA\\%sspr.dat",t_land);
  int h2=open(name,O_BINARY | O_CREAT | O_RDWR | O_TRUNC,S_IWRITE);
  if (h2==-1){perror("訡 c࠭ cࠩ⮢\7\n");exit(1);}
  write(h2,land,12288);
  close(h2);
}

//------------------------------------------------------------------
void one_qu(int x, int y, int nn)
  {
   unsigned adr=nn*32;
   for (int k=0;k<2;k++)
    for (int l=0;l<16;l++)
     {
      land[adr]=buff[y+l][x+k];
      adr++;
     }
  }

void conv_t1(int *formm)
 {
  int x=2;
  int y=16;
  int *form=formm;

  while ( *form!=0)
   {
    int n=*form;
    form++;
    if (n==255)
     { x=2; y+=48; goto M1; }
    if (n==-1)
     { x+=6; goto M1;}
    if (n<108)
     {
      one_qu(x,y,n); n=128+(n-78)*8;
      x-=2;
      one_qu(x,y,n); n++;
      y-=16;
      one_qu(x,y,n); n++;
      x+=2;
      one_qu(x,y,n); n++;
      x+=2;
      one_qu(x,y,n); n++;
      y+=16;
      one_qu(x,y,n); n++;
      y+=16;
      one_qu(x,y,n); n++;
      x-=2;
      one_qu(x,y,n); n++;
      x-=2;
      one_qu(x,y,n);
      x+=8;
      y-=16;
     }
    else
     {
      one_qu(x,y,n); n=368+(n-108)*3;
      x-=2;
      one_qu(x,y,n); n++;
      y-=16;
      one_qu(x,y,n); n++;
      x+=2;
      one_qu(x,y,n); n++;
      y+=16;
      x+=4;
     }
M1:
   }
 }

void conv_t2(int form[12][16])
 {
   int yy=0,x=0;
   for (int i=0;i<12;i++)
    {
     for (int j=0;j<16;j++)
      {
	int nn=form[i][j];
	if (nn!=-1)
	 {
	  unsigned adr=nn*32;
	  for (int k=0;k<2;k++)
	   for (int l=0;l<16;l++)
	      {
	       land[adr]=buff[yy+l][x+k];
	       adr++;
	      }
	 }
	x+=2;
      }
     x=0;
     yy+=16;
    }
 }

//---------------------------------------------------------------------

void landing(int type)
 {
  init_land();
  if (type==1)
   {
     open_f("city");
     conv_t1(l1s1);
     open_f("build");
     conv_t1(l1s2);
     open_f("land");
     conv_t2(l1s3);
     save_land();
   }
  else
   {
     open_f("land");
     conv_t2(l2s1);
     save_land();
   }
  return;
 }

int main()
{
 printf("\t ஭ (c)1996,97 M ..  \n");
 printf("  ࠩ⮢  ...");
 strcpy (t_land,"w2"); //楫 
 landing(1);
 strcpy (t_land,"w1"); //।  ᨨ
 landing(1);
 strcpy (t_land,"w3"); //
 landing(2);
 strcpy (t_land,"w4"); //
 landing(1);
 printf(" ᯥ譮.\n");
 return 0;
}

/*  1
0	࠭
1-3	ࠢ
4-5	
6	
7	஦ 
8	஦ 㭣
9-16	ய
17-25	
26-29	㣫 ॣ ()
30-38	1
39-47	2
48-50	---
51	 
52-55	 ॣ
56	 ()
57-60	ॣ (,)
61-63	
64-70	楫 
71-72	 
78	
79	ன 33
80-85	ந⥫⢮ 
86-93    
94-99	ந⥫ 㭣
100-107	 㭣
108	ந⥫⢮ 22
109	ந⥫⢮ 
110	
111	ந⥫⢮ 娡
112	娡
113-127	 
128-367	  33
368-382	  22
383	 
*/


